/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Recursively freezes the given object.
 *
 * WARNING: this function mutates Map and Set instances to override their mutating methods in order to ensure that the
 * state of those instances cannot be changed. This is necessary because calling `Object.freeze` on a Set or Map does
 * not prevent it from being mutated.
 *
 * @param object - The object to freeze.
 * @param filter - A function which returns true for objects which should be frozen and false for objects which should be ignored.
 * deepFreeze will not recurse into ignored objects.
 * If undefined, all reachable objects will be frozen.
 *
 * @internal
 */
export declare function deepFreeze<T>(object: T, filter?: (object: object) => boolean): void;
//# sourceMappingURL=deepFreeze.d.ts.map