"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockHandle = void 0;
const container_definitions_1 = require("@fluidframework/container-definitions");
const internal_1 = require("@fluidframework/runtime-utils/internal");
/**
 * Mock implementation of IFluidHandle.
 * @legacy
 * @alpha
 */
class MockHandle extends internal_1.FluidHandleBase {
    get isAttached() {
        return this.graphAttachState === container_definitions_1.AttachState.Attached;
    }
    constructor(value, path = `mock-handle-${Math.random().toString(36).slice(2)}`, absolutePath = `/${path}`) {
        super();
        this.value = value;
        this.path = path;
        this.absolutePath = absolutePath;
        this.graphAttachState = container_definitions_1.AttachState.Detached;
    }
    async get() {
        return this.value;
    }
    attachGraph() {
        this.graphAttachState = container_definitions_1.AttachState.Attached;
    }
    /**
     * @deprecated No replacement provided. Arbitrary handles may not serve as a bind source.
     */
    bind() {
        throw Error("MockHandle.bind() unimplemented.");
    }
}
exports.MockHandle = MockHandle;
//# sourceMappingURL=mockHandle.js.map