/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { FluidHandleBase } from "@fluidframework/runtime-utils/internal";
/**
 * Mock implementation of IFluidHandle.
 * @legacy
 * @alpha
 */
export declare class MockHandle<T> extends FluidHandleBase<T> {
    protected readonly value: T;
    readonly path: string;
    readonly absolutePath: string;
    private graphAttachState;
    get isAttached(): boolean;
    constructor(value: T, path?: string, absolutePath?: string);
    get(): Promise<T>;
    attachGraph(): void;
    /**
     * @deprecated No replacement provided. Arbitrary handles may not serve as a bind source.
     */
    bind(): void;
}
//# sourceMappingURL=mockHandle.d.ts.map